# -*- coding: utf-8 -*-
import time
import sys
import random
import copy
from django.db import connection
from django.utils import timezone
import urllib2
import traceback

from amazonproduct.errors import AWSError
from sale_amazon.config import *
from sale_amazon.interface.inter.Amazon_api import Amazon_MWS,Amazon_AWS
from sale_amazon.models.listing import AmazonListingProductMethod
from sale_amazon.settings import PROJECT_DIRECTORY

proxy_index = 1
base_path_list = ['/home/ec2e', '/home/zhaolei']
#base_path = PROJECT_DIRECTORY
base_path = base_path_list[proxy_index-1]
info_path = base_path+'/amazon_listing_info'
log_file_name = '{base_dir}/log/{date}_{random}.log'.format(base_dir=info_path,
                        date=timezone.now().strftime('%Y-%m-%d'), random=random.randint(100, 999))

reload(sys)
sys.setdefaultencoding('utf-8')


def wki_log(msg):
    with open(log_file_name, 'a+') as f:  # 没必要对log加锁
        f.write(timezone.now().strftime('%Y-%m-%d %H:%M:%S')+', ')
        f.write(msg)
        f.write('\n')


def get_first_upload_time():
    cursor = connection.cursor()
    cursor.execute(
        "update sysproduct_sku_online_order a,( select a.gmt,c.sku from (select asin_id, min(create_time) as gmt from amazon_listing_variations group by asin_id) a ,amazon_listing_product sk,sysproduct_sku_product c where  a.asin_id=sk.asin and sk.sysproduct_sku_id=c.id) b set write_time=utc_timestamp(),a.amazon_online_time=b.gmt where a.sku=b.sku and a.amazon_online_time is null")
    cursor.execute("insert into sysproduct_sku_online_order(aliexpress_online_time,sku,create_time, write_time) (select a.gmt,c.sku, utc_timestamp(), utc_timestamp() from (select asin_id, min(create_time) as gmt from amazon_listing_variations group by asin_id) a ,amazon_listing_product sk,sysproduct_sku_product c where  a.asin_id=sk.asin and sk.sysproduct_sku_id=c.id and c.sku not in (select sku from sysproduct_sku_online_order));")
    cursor.close()


def get_listing(account):
    error_num = 0
    time_out_request_base = []
    time_out_sale_rank = []
    return_data = None

    try:
        print "*********************start:", account.name
        wki_log("start: " + account.name)
        my_mws = Amazon_MWS(account)
        try:
            return_data = my_mws.get_product_report(type='_GET_MERCHANT_LISTINGS_DATA_')
        except Exception,e:
            num = 0
            while num <= 5:
                time.sleep(10)
                try:
                    return_data = my_mws.get_product_report(type='_GET_MERCHANT_LISTINGS_DATA_')
                except Exception, e:
                    pass
                if return_data:
                    break
                num += 1
        if not return_data:
            print "*********************fail (get_product_report):", account.name
            wki_log("fail (get_product_report): " + account.name)
            return
        else:
            wki_log(account.name + " listing count: " + str(len(return_data)))

        curr_dt = timezone.now().strftime('%Y-%m-%d')
        extra_info = []
        for key in return_data:
            if key.get('asin1'):
                extra_info.append({'asin': key.get('asin1'), 'fulfillment-channel': key.get('fulfillment-channel', ''),
                    'seller_sku': key.get('seller-sku', ''), 'item_condition': key.get('item-condition', ''),
                    'price': key.get('price', ''), 'quantity': key.get('quantity', ''), 'open-date': key.get('open-date', '')})

        #获取amazon店铺产品的基本信息
        time_out_request_base = read_amazon_listing_product(list(set([key.get('asin1') for key in return_data])), account, curr_dt)
        # test asin_test_list = ['B016RM85CE', 'B01MG1EEII', 'B00N9SDY5S', 'B00PTX915S', 'B00IUMCFOO', 'B00FG7KQQ0', 'B01DXKS8HU', 'B011QI8Y1G', 'B00IBDSS8E', 'B00MUB01NI']
        # test time_out_request_base = read_amazon_listing_product(asin_test_list, account, extra_info, curr_dt)
        request_num = 0
        while len(time_out_request_base) > 0:
            request_num += 1
            if request_num > 3:
                break
            time_out_request_base = read_amazon_listing_product(time_out_request_base, account, curr_dt)
        #获取amazon店铺产品的基本信息 结束
        
        if len(time_out_request_base) > 0:
            wki_log("fail (read_amazon_listing_product): " + account.name + ': '+str(time_out_request_base))

        save_amazon_listing_extra_info(account, extra_info, curr_dt)

        #获取amazon的店铺产品的关系（父子）
        time_out_request_relationship = create_relationship(return_data, account, my_mws, curr_dt)
        request_num = 0
        if len(time_out_request_relationship) > 0:
            wki_log('time_out_request_relationship: '+str(time_out_request_relationship))  # !!! just save to log, should modify
            #request_num +=1
            #if request_num >3:
            #    break
            #time_out_request_relationship = create_amazon_listing_product(time_out_request_relationship, account)
        #获取amazon的店铺产品的关系（父子） 结束

        # 空间不足,压缩后删除
        os.chdir(info_path)
        os.system('tar -czvf "' + account.name + '.tar.gz" "(' + account.name + ')_base_' + curr_dt + '.csv" "('
                  + account.name + ')_fba_' + curr_dt + '.csv" "(' + account.name + ')_extra_' + curr_dt + '.csv"')
        os.system('rm "(' + account.name + ')_base_' + curr_dt + '.csv"')
        os.system('rm "(' + account.name + ')_fba_' + curr_dt + '.csv"')
        os.system('rm "(' + account.name + ')_extra_' + curr_dt + '.csv"')

        print "*********************end:", account.name
        wki_log("end: " + account.name)

        count = 0
        while count < 5:
            ret = send_request(account.name)
            time.sleep(20)
            if ret == 0:
                break
            count += 1
    except Exception,e:
        print e
        print "*********************end faild:", account.name
        wki_log("end and except: " + account.name)
        wki_log(traceback.format_exc())
        #raise e


def send_request(account_name):
    try:
        req = urllib2.Request('http://122.5.32.82:8000/sale_amazon/notify/syncfile/?store='+account_name+'&proxy_index='+str(proxy_index))
        #req = urllib2.Request('http://115.239.210.27')
        conn = urllib2.urlopen(req, timeout=20)
        wki_log('send request: ' + account_name)
        conn.close()
        return 0
    except:
        wki_log("send request fail: " + account_name)
        wki_log(traceback.format_exc())
        return 1


def send_request2():
    try:
        req = urllib2.Request('http://122.5.32.82:8000/sale_amazon/notify/syncreport/')
        conn = urllib2.urlopen(req, timeout=20)
        wki_log('send report request')
        conn.close()
        return 0
    except:
        wki_log("send report request fail: ")
        wki_log(traceback.format_exc())
        return 1


def create_amazon_listing_product(asins,account):
    time_out_request_base = []
    time_out_sale_rank = []
    request_asin = []
    for asin in asins:
        if not asin:
            continue
        request_asin.append(asin)
        if len(request_asin) >= 10:
            large_product_info,request_asin = get_product_base_info(request_asin,account)
            if not large_product_info:
                time_out_request_base.extend(request_asin)
            else:
                AmazonListingProductMethod.create_amazon_listing_product(large_product_info, account)
                sale_ranks = get_product_sales_ranks(request_asin,account)
                AmazonListingProductMethod.set_listing_product_sale_rank(sale_ranks)
            request_asin = []

    if len(request_asin) > 0:
        large_product_info, request_asin = get_product_base_info(request_asin, account)
        if not large_product_info:
            time_out_request_base.extend(request_asin)
        else:
            AmazonListingProductMethod.create_amazon_listing_product(large_product_info, account)
            sale_ranks = get_product_sales_ranks(request_asin, account)
            AmazonListingProductMethod.set_listing_product_sale_rank(sale_ranks)
        request_asin = []
    return time_out_request_base


def read_amazon_listing_product(asins, account, curr_dt):
    file_path = '{base_dir}/({store})_{type}_{datetime}.csv'.format(base_dir=info_path,
                                                             store=account.name,
                                                             type = 'base',
                                                             datetime=curr_dt)
    time_out_request_base = []
    time_out_sale_rank = []
    request_asin = []
    for asin in asins:
        if not asin:
            continue
        request_asin.append(asin)
        if len(request_asin) >= 10:
            original_asin = copy.deepcopy(request_asin)
            large_product_info, request_asin = get_product_base_info(request_asin, account)
            if not large_product_info:
                time_out_request_base.extend(request_asin)
            else:
                if set(original_asin)-set(request_asin):
                    time_out_request_base.extend(set(original_asin)-set(request_asin))
                #AmazonListingProductMethod.create_amazon_listing_product(large_product_info, account)
                # ！ sale_ranks = get_product_sales_ranks(request_asin, account)
                #AmazonListingProductMethod.set_listing_product_sale_rank(sale_ranks)
                save_amazon_listing_base_info(large_product_info, file_path)
            request_asin = []

    if len(request_asin) > 0:
        original_asin = copy.deepcopy(request_asin)
        large_product_info, request_asin = get_product_base_info(request_asin, account)
        if not large_product_info:
            time_out_request_base.extend(request_asin)
        else:
            if set(original_asin) - set(request_asin):
                time_out_request_base.extend(set(original_asin) - set(request_asin))
            #AmazonListingProductMethod.create_amazon_listing_product(large_product_info, account)
            # ！ sale_ranks = get_product_sales_ranks(request_asin, account)
            #AmazonListingProductMethod.set_listing_product_sale_rank(sale_ranks)
            save_amazon_listing_base_info(large_product_info, file_path)
        request_asin = []

    return time_out_request_base


def save_amazon_listing_base_info(product_list, file_path):
    with open(file_path, 'a+') as amazon_info_file:
        for key in product_list:
            info = product_list[key]
            title = info.get('title', '')
            seller_sku_first = info.get('seller_sku', '')
            brand = info.get('brand', '')
            medium_image = info.get('medium_image', '')
            main_image = info.get('main_image', '')
            images_url = info.get('images_url', [])
            detail = info.get('detail', '').replace('\t', '    ')
            keyword = ''  # ???
            variations = info.get('variations', '')
            currency = info.get('currency', '')
            lowest_price = info.get('lowest_price', '')
            seller_num = info.get('offers_num', '')
            sale_rank = info.get('sales_rank', '')
            parent_asin = info.get('parent_asin', '')
            #if key in sale_ranks:
            #    sale_rank2 = sale_ranks[key].get('sale_rank', '')
            #else:
            #    sale_rank2 = ''
            amazon_info_file.write('{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\n'.format
                (key, title, seller_sku_first, brand, medium_image, main_image, images_url, detail, keyword,
                variations, currency, lowest_price, seller_num, sale_rank, parent_asin))
        amazon_info_file.flush()


def save_amazon_listing_extra_info(account, extra_info, curr_dt):
    file_path_ex = '{base_dir}/({store})_{type}_{datetime}.csv'.format(base_dir=info_path,
                                                                       store=account.name,
                                                                       type='extra',
                                                                       datetime=curr_dt)
    with open(file_path_ex, 'a+') as amazon_info_file_ex:
        for _info in extra_info:
            asin = _info.get('asin', '')
            channel = _info.get('fulfillment-channel', '')
            seller_sku = _info.get('seller_sku', '')
            item_condition = _info.get('item_condition', '')
            price = _info.get('price', '')
            quantity = _info.get('quantity', '')
            open_date = _info.get('open-date', '')
            amazon_info_file_ex.write('{}\t{}\t{}\t{}\t{}\t{}\t{}\n'.format(asin, channel, seller_sku, item_condition, price, quantity, open_date))
        amazon_info_file_ex.flush()


def create_relationship(return_data,account,my_mws,curr_dt):
    file_path_fba = '{base_dir}/({store})_{type}_{datetime}.csv'.format(base_dir=info_path,
                                                                    store=account.name,
                                                                    type='fba',
                                                                    datetime=curr_dt)
    #file_path_relation = '{base_dir}/({store})_{type}_{datetime}.csv'.format(base_dir=info_path,
    #                                                                store=account.name,
    #                                                                type='relation',
    #                                                                datetime=curr_dt)

    time_out_request = []
    '''
    i = 0
    aws_request_product = []
    for return_product in return_data:  ## report获取数据，如果是fba直接存到 listing和lisitngvariation表中
        if not return_product:
            continue
        # asin = return_product.get('asin1')
        if return_product.get('fulfillment-channel') == "AMAZON_NA":
            i += 1
            # !!!
            # save to file
            #parent_amazon_listing = AmazonListingMethod.create_amazon_listing_by_report(account, asin, 2,
            #                                                                            return_product)
            #AmazonListingVariationsMethod.create_amazon_variations_by_report(parent_amazon_listing, asin, account,
            #                                                                 return_product)
        else:  # report获取数据，如果不是是fba，我们通过aws来获取父子关系,先保存起来，后面十个十个的来获取关系
            aws_request_product.append(return_product)
    time.sleep(10)
    '''
    fba_return_data = []
    try:
        fba_return_data = my_mws.get_product_report(type='_GET_AFN_INVENTORY_DATA_')
    except:
        num = 0
        while num<=10:
            time.sleep(10)
            try:
                fba_return_data = my_mws.get_product_report(type='_GET_AFN_INVENTORY_DATA_')
            except Exception,e:
                pass
            if fba_return_data:
                break
            num +=1
    #for FBA_quantity in FBA_return_data:
    #    if FBA_quantity.get('Warehouse-Condition-code') == 'SELLABLE':
            # amazon_listing = AmazonListingVariations.objects.filter(seller_sku=FBA_quantity.get('seller-sku')).update(listing_status=1,quantity=FBA_quantity.get('Quantity Available'))

    if fba_return_data:
        save_amazon_listing_fba_info(file_path_fba, fba_return_data)
    else:
        wki_log("fail(_GET_AFN_INVENTORY_DATA_): "+account.name)

    # ##获取关系，并保存再一个字典中，key是asin
    '''
    request_product = []
    request_asin = []
    for item in aws_request_product:
        request_asin.append(item.get('asin1'))
        request_product.append(item)
        if len(request_asin) >= 10:
            time.sleep(5)
            relationship_item = {}
            try:
                relationship_item = my_mws.get_product_product_relationship(list(set(request_asin)))
            except Exception,e:
                num = 0
                while num <= 5:
                    time.sleep(5)
                    try:
                        relationship_item = my_mws.get_product_product_relationship(list(set(request_asin)))
                    except Exception, e:
                        pass
                    if relationship_item:
                        break
                    num += 1
                if not relationship_item:
                    time_out_request.extend(request_asin)
            #create_listing_and_variations(account, request_product, relationship_item)
            save_amazon_listing_relation_info(file_path_relation, relationship_item)
            request_asin = []
            request_product = []
    relationship_item = {}
    if len(request_asin) > 0:
        time.sleep(5)
        try:
            relationship_item = my_mws.get_product_product_relationship(request_asin)
        except Exception, e:
            num = 0
            while num <= 5:
                time.sleep(5)
                try:
                    relationship_item = my_mws.get_product_product_relationship(request_asin)
                except Exception, e:
                    pass
                if relationship_item:
                    break
                num += 1
            if not relationship_item:
                time_out_request.extend(request_asin)
        #create_listing_and_variations(account, request_product, relationship_item)
        save_amazon_listing_relation_info(file_path_relation, relationship_item)
    '''
    return time_out_request


def save_amazon_listing_fba_info(path, fba_return_data):
    with open(path, 'a+') as amazon_fba_info_file:
        for FBA_quantity in fba_return_data:
            if FBA_quantity.get('Warehouse-Condition-code') == 'SELLABLE':
                asin = FBA_quantity.get('asin', '')
                seller_sku = FBA_quantity.get('seller-sku', '')
                quantity = FBA_quantity.get('Quantity Available', '0')
                amazon_fba_info_file.write('{}\t{}\t{}\n'.format(asin, seller_sku, quantity))
        amazon_fba_info_file.flush()


def save_amazon_listing_relation_info(path, relationship_item):
    with open(path, 'a+') as amazon_info_file:
        for key in relationship_item:
            info = relationship_item[key]
            parent = info.get('parent', '')
            amazon_info_file.write('{}\t{}\n'.format(key, parent))
        amazon_info_file.flush()


def get_product_base_info(request_asin,account):
    '''获取十个asin得基本信息'''
    my_aws = Amazon_AWS()
    time.sleep(5)
    large_product_info = {}
    try:
        large_product_info = my_aws.get_product_large(request_asin, local=MARKET_TO_REGION.get(account.MKPLACEID))
    except AWSError, e:
        if e.code == 'AWS.InvalidParameterValue':
            e_str = str(e)
            asin_error = e_str.split(' ')[1].replace('\'','')
            request_asin.remove(asin_error)
            num = 0
            while num <= 5:
                time.sleep(5)
                try:
                    large_product_info = my_aws.get_product_large(request_asin,
                                                                  local=MARKET_TO_REGION.get(account.MKPLACEID))
                except AWSError, e:
                    if e.code == 'AWS.InvalidParameterValue':
                        e_str = str(e)
                        asin_error = e_str.split(' ')[1]
                        request_asin.remove(asin_error)
                except Exception, e:
                    pass
                if large_product_info:
                    break
                num += 1
    except Exception, e:
        num = 0
        while num <= 5:
            time.sleep(5)
            try:
                large_product_info = my_aws.get_product_large(request_asin,
                                                              local=MARKET_TO_REGION.get(account.MKPLACEID))
            except AWSError, e:
                if e.code == 'AWS.InvalidParameterValue':
                    e_str = str(e)
                    asin_error = e_str.split(' ')[1]
                    request_asin.remove(asin_error)
            except Exception, e:
                pass
            if large_product_info:
                break
            num += 1
    return large_product_info,request_asin


def get_product_sales_ranks(request_asin,account):
    '''获取10个asin得排名信息'''
    sale_ranks = {}
    my_aws = Amazon_AWS()
    time.sleep(5)
    try:
        sale_ranks = my_aws.get_product_sales_rank(request_asin, local=MARKET_TO_REGION.get(account.MKPLACEID))
    except Exception, e:
        time.sleep(5)
        num = 0
        while num <=5:
            try:
                sale_ranks = my_aws.get_product_sales_rank(request_asin, local=MARKET_TO_REGION.get(
                    account.MKPLACEID))
            except Exception, e:
                pass
            num+=1
    return sale_ranks
